/*
 *      
 *   HTML.
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "compile.h"
#include "strutils.h"
#include "proto.h"
#include "alfa.h"

extern int mkdir (char *path, unsigned mode);
extern char FakOutPath[], fname[];
extern int my_userMatch (char **p);
extern void load_fak();

extern alfacoll Alfa1,Alfa2,CAlfa,Srg1,Srg2,Subst;

int trOpen, tableOpen;

FILE *pattern, *lpattern;

char InFileName[256],OutFileName[256];
char OutPath[256]="HTML";

void calcoutname(void) {
  strcpy(OutFileName,OutPath);
  strcat(OutFileName,InFileName);
  rep(OutFileName,".txt",".html");
} //calcoutname

void split(void) {
  char **sp;

  if (text) return;

  if (strcmp(ch3,"mallng")==0)
    strcpy(fname,"mallng.html"); //!!!

  for (sp=spl; *sp; sp++)
    if (strcmp(ch1,*sp)==0) break;
  if (*sp==NULL) return;
  sp+=splitno+1;
  if (*sp && **sp && strcmp(ch3,*sp)==0) {
    printf("<hr />\r\n");
    printf("<small><b><a href=\"%s.html#kmnc\">",ch3);
    printf("&gt;&gt;&gt;</a></b></small><hr />");
    epilogue(stdout,pattern,"");
    sprintf(OutFileName,"%s%s.%s",OutPath,ch3,suffix);
    sprintf(fname,"%s.%s",ch3,suffix);
    freopen(OutFileName,"wb",stdout);
    splitno++;
    strcpy(charname,ch3);
    pattern=prologue(stdout,"page.pat",charname);
  } //if
} //split

FILE *ind;
char wrd[256];
int state;

// Kontrolu vortofinon
int endword(char *c) {
  switch (*c) {
    case '[': case ']':
    case '<': case '>': case '{': case '}':
    case ' ': case ',': case '.': case ';': case ':':
    case '%': case '"': case '=': case '_': case '#':
    case '?': case '!': case '*':
      return 1;
    case '(': case ')':
      switch (c[1]) {
        case ' ': case '.': case ';': case ':': case ',': case '"':
        case '?': case '!': case '=': case '_': case '#': case '*':
        case '<': case '>':
          return 1;
        default:
          return 0;
      } //switch
    default:
      return 0;
  } //switch
} //endword

char wrd0[256],wrd3[10];

// Prenu vorton
char *getwrd(char *p) {
  char *pp, *ppp;

  while (*p && endword(p)) {
    switch (*p) {
      case '[':
        if ((state&8)==0) {
          state|=2; state&=~1;    //kapvorto
        }
        else
          state|=128;             //ekzemplo
        break;
      case ']':
        if ((state&8)==0) {
          state&=~2; state|=1;    //difino
        }
        else
          state&=~128;
        break;
      case '_':                   //komento
        if (state&4) {
          state&=~4; state|=1;
        }
        else {
          state|=4; state&=~1;
        }
        break;
      case '{':                   //ekzemplo
        state|=8; state&=~1;
        break;
      case '}':
        state&=~8; state|=1;
        break;
      case '%':
        if (state&16)
          state&=~16;
        else
          state|=16;
        break;
      case '<':                  //referenco
        if (p[1]!='*') {state|=32; state&=~1;}
        break;
      case '>':
        if (p[-1]!='*') {state&=~32; state|=1;}
        break;
      case '(':
        if (p[1]=='*') {         //rimarko
          state|=64; p++;
        }
        else if (p[1]=='=') {    //sinonimo
          state|=256; p++;
        }
        break;
      case '=':
        state|=256;
        break;
      case '*':
        if (p[1]==')') { state&=~64; p++;}
        break;
      case ')':
      case '.':
      case ';':
        state&=~256;
        break;
    } //switch
    p++;
  } //while
  p=skipspc(p);

  if (strncmp(p,"(la) ",5)==0) p+=5;
  if (strncmp(p,"la ",3)==0) p+=3;

  for (pp=wrd; *p; p++) {
    if (*p!=' ' && endword(p)) {
      *pp=0;
      p=skipspc(p);
      break;
    }
    else {
      switch (*p) {
        case '`': case '/':
        case '|': case '*':
          break;
        case '@':
          while (*p && *p!=']' && *p!=',') p++;
          p--;
          break;
        default:
          *pp++=*p;
      } //switch
    } //if
  } //for
  *pp=0;

  tilde(wrd);
  tilde(wrd);
  strcpy(wrd0,wrd);
  rep(wrd,"(","");
  rep(wrd,")","");
  pp=strchr(wrd0,'(');
  ppp=strchr(wrd0,')');
  if (ppp==NULL) ppp=wrd0+strlen(wrd0);
  if (pp)
    del(pp,ppp-pp);
  rep(wrd0,"(","");
  rep(wrd0,")","");
  return p;
} //getwrd

int pezo(char *p) {
  int i,j,k;
  char *pp;
  int skip,kurs;

  skip=0; kurs=0;
  i=j=k=0;
  for (pp=buf; pp<=p; pp++) {
    if (*pp=='[') skip=1;
    else if (*pp==']') skip=0;
    else if (*pp=='_') kurs=!kurs;
    if (skip||kurs) continue;

    if (*pp==';') {
      i++;
      j=k=0;
    }
    else if (*pp==',') {
      j++;
      k=0;
    }
    else if (*pp==' ')
      k++;
  } //for

  return i+j*10+k*100;
} //pezo

void putindex(char *ww, int n, char *base, int state) {
  char *w,*p,*pp;
  char buf0[MAXLEN],buf[MAXLEN],buf1[MAXLEN],buf2[MAXLEN];
  char s[MAXLEN];
  int mask=256|128|32|2;

  while (rep(ww," ","_"));
  strcpy(buf,ww);
  while (rep(buf,"-",""));
  while (rep(buf," ",""));

  //tokey(buf,(state&mask)?alfa1:alfa2,s);
  toKey(buf,(state&mask)?&Alfa1:&Alfa2,s);
  while (rep(s," ",""));
  if (s[0]==0) return;

  strcpy(buf1,buf);
  //to_lower(buf1,(state&mask)?alfa1:alfa2);
  to_Lower(buf1,(state&mask)?&Alfa1:&Alfa2);
  strcpy(buf2,base);
  //to_lower(buf2,calfa);
  to_Lower(buf2,&CAlfa);
  p=strchr(buf2,',');
  if (p) *p=0;

  fprintf(ind,"%01d %s %04d ",(state&mask)?1:2,s,n);
  fprintf(ind,"%s <%s#%s> ",buf1,fname,buf2);
  fprintf(ind,"%s <%s>\r\n",ww,base);

  w=ww;
  if (strchr(w,'_'))
    while (w && *w) {
      pp=strchr(w,'_');
      if (pp) *pp++=0;

      strcpy(buf1,w);
      while (rep(buf1,"-",""));
      toKey(buf1,(state&mask)?&Alfa1:&Alfa2,s);

      while (rep(s," ",""));
      if (s[0] && (strcmp(w,"I") && strcmp(w,"II") && strcmp(w,"III"))) {
        strcpy(buf1,w);
        while (rep(buf1,"-",""));
        to_Lower(buf1,(state&mask)?&Alfa1:&Alfa2);
        strcpy(buf2,base);
        to_Lower(buf2,&CAlfa);
        p=strchr(buf2,',');
        if (p) *p=0;

        fprintf(ind,"%01d %s %04d ",(state&mask)?1:2,s,n<9999?9998:n);
        fprintf(ind,"%s <%s#%s> ",buf1,fname,buf2);
        fprintf(ind,"%s <%s>\r\n",w,base);
      }
      w=pp;
    } //while
} //putindex

void indeksigu (void) {
  char *p,*w,*pp;
  char base[MAXLEN];
  char w1[MAXLEN], w2[MAXLEN];
  int i,n;
  int flag;

  strcpy(base,key1);
  first=1;
  state=0;
  p=buf;
  flag=0;
  while (*p) {
    p=getwrd(p);
    if (wrd[0]==0) continue;
    if (wrd[0]==' ') continue;
    if (state&64) continue; //rimarko
    if (state&2) {  //titolvorto
      if (flag || base[0]==0 || strcmp(base,key1)==0)
        strcpy(base,wrd);
      else {
        strcat(base,",");
        strcat(base,wrd);
      }
      flag=0;
    }
    else
      flag=1;

    //while (rep(base,"-",""));
    while (rep(base," ","_"));
    while (rep(base,"_,","__"));
    n=pezo(p);
    if (state&4) continue; //komento
    if ((state&2) || (state&1) || (state&8) || (state&256) || (state&32)) {
      if (state&8) n=9999;
      while (wrd[strlen(wrd)-1]==' ')
        wrd[strlen(wrd)-1]=0;
      while (rep(wrd," ","_"));
      while (wrd0[strlen(wrd0)-1]==' ')
        wrd0[strlen(wrd0)-1]=0;
      while (rep(wrd0," ","_"));

      putindex(wrd,n,base,state);

      if (wrd0[0] && strcmp(wrd,wrd0))
        putindex(wrd0,n,base,state);

      if ((state&2)==0) flag=1;
    } //if
  } //while
} //indeksigu

extern char ch1[], ch2[], ch3[], oldch1[], oldch2[], oldch3[];

#define MAXFILES 100
char *filelist[MAXFILES];

/* Metu du- kaj triliterajn markojn */
void _putHr(void) {
  char *html;
  int i;

  html=strrchr(OutFileName,'/');
  if (html) html++;
  else html=OutFileName;

  printf("\r\n");
  if (strcmp(ch1,oldch1)) {
    printf("<a id=\"__%s\" name=\"__%s\"></a>",ch1,ch1);
  }

  if (strcmp(ch2,oldch2) && strcmp(ch2,ch1)) {
    printf("<a id=\"__%s\" name=\"__%s\"></a>",ch2,ch2);
  }

  if (strcmp(ch3,oldch3)) {
    if (strcmp(ch3,ch2) && strcmp(ch3,ch1))
      printf("<a id=\"__%s\" name=\"__%s\"></a>",ch3,ch3);
  } //if

  printf("<hr />");
  printf("\r\n");

  strcpy(oldch1,ch1);
  strcpy(oldch2,ch2);
  strcpy(oldch3,ch3);
} //_putHr

// Cxefa programo
int main(int argc, char *argv[]) {
  char c;
  char *p,*pp;
  char letter[256], s[256];
  int a,i,j,skip;

  LoadColl("alfa1.cfg",&Alfa1);
  LoadColl("alfa2.cfg",&Alfa2);
  joinAlfa(&Alfa1,&Alfa2,&CAlfa);
  LoadColl("srg1.cfg", &Srg1);
  LoadColl("srg2.cfg", &Srg2);
  LoadColl("subst.cfg",&Subst);

  load_list("split.cfg",spl,256);
  load_list("filelist.cfg",filelist,MAXFILES);
  load_fak();

  putHr=_putHr; //putword=_putword;

  userMatch=my_userMatch; //!!!

  counter=nestoj=radikoj=0;
  searching=0;
  //OutPath[0]=0;
  for (a=1; a<argc; a++) {
    if (strcmp(argv[a],"-t")==0)
      text=1;
    else if (strcmp(argv[a],"-p")==0)
      strcpy(OutPath,argv[++a]);
    else
      strcpy(OutPath,argv[a]);
  }
  if (OutPath[0] && OutPath[strlen(OutPath)]!='/')
    strcat(OutPath,"/");
  mkdir(OutPath,0777);

  strcpy(FakOutPath,OutPath);
  strcat(FakOutPath,"FAK/");
  rep(FakOutPath,"//","/");
  mkdir(FakOutPath,0777);

  ind=fopen("rindex.ind","wb");
  for (i=0; filelist[i]; i++) {
    strcpy(fname,filelist[i]); //!!!
    rep(fname,"*","");
    rep(fname,".txt",".html");

    splitno=0;
    strcpy(InFileName,filelist[i]);
    if (InFileName[0]==0) break;
    rep(InFileName,"*","");
    indekse=(strchr(filelist[i],'*')==NULL);
    strcpy(letter,InFileName);
    rep(letter,".txt","");
    letter[0]=toupper(letter[0]);
    fprintf(stderr,"%s ",letter);
    getnkey(charname,InFileName,1);
    pp=charname; p=InFileName;
    while (*p && *p!='.')
      if (*pp++!=*p++) {
        text=1; break;
      }
    if (strcmp(InFileName,"mallng.txt")==0) charname[0]=0;
    calcoutname();
    if (strcmp(InFileName,OutFileName)==0) break;
    skip=0;
    if (!freopen(InFileName,"r",stdin)) skip=1;
    else if (!freopen(OutFileName,"wb",stdout)) break;

    if (!skip) {
      char oldword[256], nkey[256], oldnkey[256];
      pattern=prologue(stdout,"page.pat",charname);
      p=buf;
      oldword[0]=0;
      do {
        c=(char)getsym();
        *p++=c;
        *p=0;
        if (eop) {
          compile();
          if (indekse) indeksigu();
          if (indekse) counter++;
          p=buf;

          while (rep(key,"(",""));
          while (rep(key,")",""));
          while (rep(key,",",""));
          while (rep(key,"'",""));
          //to_lower(key,calfa);
          to_Lower(key,&CAlfa);
          //tokey(key,calfa,nkey);
          toKey(key,&CAlfa,nkey);
          if (strcmp(nkey,oldnkey)<0 && nkey[0] && oldword[0] && strcmp(InFileName,"mallng.txt"))
            fprintf(stderr,"\n  '%s' (%s) < '%s' (%s)",key,nkey,oldword,oldnkey);
          strcpy(oldword,key);
          strcpy(oldnkey,nkey);
        }
      } while (!feof(stdin));
      printf("<hr />");
      epilogue(stdout,pattern,"");
      fclose(stdout);
    } //if
    //fprintf(stderr,"Ok!\n");
  } //for
  fclose(ind);

  strcpy(s,OutPath);
  strcat(s,"kovril.html");
  protofile("kovril.pat",s);

  fprintf(stderr,"\nNestoj: %d / ",nestoj);
  fprintf(stderr,"Artikoloj: %d / ",counter);
  fprintf(stderr,"Radikoj: %d\n",radikoj);

  make_fak();

  fprintf(stderr,"\n");
  //fprintf(stderr,"Ordigo...\n");
  system("sort rindex.ind >rindex1.ind");

  unlink("rindex.ind");
  rename("rindex1.ind","rindex.ind");

  make_index();
  return 0;
} //main
