/*
 *    
 */
#include <stdio.h>
#include <string.h>

#include "strutils.h"

#define MAXLEN 256
#define BUFLEN 512
#define COLLEN 2048

char *Coll[COLLEN],*Coll2[COLLEN];
int Len=0,Len2=0;

char path[MAXLEN];
char Mode[80];
char q[MAXLEN],q0[MAXLEN];

int curmode=0;

void getword(char **s) {
  char buf[MAXLEN+32];
  char *p,*pp,*begword,*endword;
  int wmode=-1;

  p=buf; begword=endword=*s;
  while (**s) {
    if (strncmp(*s,"<i>",3)==0)
      curmode|=1;
    else if (strncmp(*s,"</i>",4)==0)
      curmode&=~1;
    else if (strncmp(*s,"<dt>",4)==0)
      curmode|=2;
    else if (strncmp(*s,"</dt>",5)==0)
      curmode&=~2;
    else if (strncmp(*s,"<small>",7)==0)
      curmode|=4;
    else if (strncmp(*s,"</small>",8)==0)
      curmode&=~4;

    if (strncmp(*s,"<span class=\"rad\">",18)==0) {
      if (wmode==-1) {
        wmode=curmode;
        begword=*s;
      }
      (*s)+=18;
      endword=*s;
    }
    else if (strncmp(*s,"<span ",6)==0 || strncmp(*s,"</span>",7)==0) {
      while (**s && **s!='>')
        (*s)++;
      if (**s=='>') (*s)++;
      if (wmode==-1) {
        wmode=curmode;
        begword=*s;
      }
      endword=*s;
    }
    else if (**s=='<' && strncmp(*s,"<em>",4) && strncmp(*s,"</em>",5)) {
      while (**s && **s!='>')
        (*s)++;
      if (**s=='>') (*s)++;
      break;
    }
    else if (**s==' ' || **s=='\n' ||
        **s=='.' || **s==',' || **s==';' || **s==':' ||
        **s=='=' || **s=='!' || **s=='?') {
      (*s)++;
      break;
    }
    else if (**s=='&') {
      if (wmode==-1) {
        wmode=curmode;
        begword=*s;
      }
      while (**s && **s!=';')
        *p++=*(*s)++;
      *p++=*(*s)++;
      endword=*s;
    }
    else {
      if (wmode==-1) {
        wmode=curmode;
        begword=*s;
      }
      *p++=*(*s)++;
      endword=*s;
    }
  }
  *p=0;
  uni_decode(buf);

  while (rep(buf,"<em>", ""));
  while (rep(buf,"</em>", ""));
  while (rep(buf,"&#8211;", ""));
  while (rep(buf,"&#183;", ""));
  while (rep(buf,"&#769;", ""));
  while (rep(buf,"*", ""));
  while (rep(buf,"-", ""));
  while (rep(buf,"=", ""));
  while (rep(buf,"&mdash;", ""));
  while (rep(buf,"&ndash;", ""));
  while (rep(buf,"&laquo;", ""));
  while (rep(buf,"&raquo;", ""));
  while (rep(buf,"&gt;", ""));
  while (rep(buf,"&lt;", ""));
  while (rep(buf,"<span class=\"rad\">", ""));
  while (rep(buf,"</span>", ""));
  while (rep(buf,"\"", ""));
  while (rep(buf,"\'", ""));
  while (rep(buf,"/", ""));

  //neparaj krampoj
  if (strchr(buf,'(') && !strchr(buf,')')) {
    if (buf[0]=='(') begword++;
    rep(buf,"(","");
  }
  if (strchr(buf,')') && !strchr(buf,'(')) {
    if (buf[strlen(buf)-1]==')') endword--;
    rep(buf,")","");
  }
  if (buf[0]=='(' && buf[strlen(buf)-1]==')') {
    del(buf,1);
    buf[strlen(buf)-1]=0;
    begword++; endword--;
  }

  //kadrantaj citiloj
  if (strncmp(begword,"&laquo;",7)==0)
    begword+=7;
  if (strncmp(endword-7,"&raquo;",7)==0)
    endword-=7;

  toLower(buf);
  if (buf[0]) {
    if (strchr(Mode,'k') && (wmode&1));
    else if (strchr(Mode,'v') && (wmode&2));
    else if (strchr(Mode,'e') && (wmode&4));
    else if (strchr(Mode,'t') && (wmode==0));
    else return;
    if (wcmp(q,buf)) {
      ins(endword,"</span>");
      ins(begword,"<span class=\"found\">");
      (*s)+=strlen("<span class=\"found\">")+strlen("</span>");
    }
  } //if
} //getword

void ReadLn(FILE *F) {
  char c;
  while (!feof(F)) {
    if (fread(&c,1,1,F)<=0) break;
    if (c==0 || c=='\n') break;
  }
} //ReadLn

void ReadWordLn(FILE *F, char *buf) {
  char c;
  while (!feof(F)) {
    if (fread(&c,1,1,F)<=0) break;
    if (c==0 || c==' ' || c=='\n' || c=='\r') break;
    *buf++=c;
  }
  *buf++=0;

  if (c!='\n') ReadLn(F);
} //ReadWordLn

int ReadWord(FILE *F, char *buf) {
  char c;
  while (!feof(F)) {
    if (fread(&c,1,1,F)<=0) break;
    if (c==0 || c==' ' || c=='\n' || c=='\r') break;
    *buf++=c;
  }
  *buf++=0;

  if (c=='\n') return 0;
  return 1;
} //ReadWord

void ReadHTMLWord(FILE *F, char *buf) {
  char c;
  char *p;
  while (!feof(F)) {
    if (fread(&c,1,1,F)<=0) break;
    if (c=='<') {
      p=buf;
      *buf++=c;
      while (!feof(F) && c!='>') {
        if (fread(&c,1,1,F)<=0) break;
        *buf++=c;
      }
      if (strncmp(p,"<a ",3)==0) break;
      if (strncmp(p,"</a",3)==0) break;
      if (strncmp(p,"<dl",3)==0) break;
      if (strncmp(p,"</dl",3)==0) break;
    }
    else if (c==' ' || c=='\n') {
      *buf++=c;
      break;
    }
    else if (c==0)
      break;
    else
      *buf++=c;
  }
  *buf++=0;
} //ReadHTMLWord


int Find(char *s,char *t[],int Len) {
  int L,H,I,C;

  L=0; H=Len-1;
  while (L<=H) {
    I=(L+H)/2;
    C=strcmp(t[I],s);
    if (C<0)
      L=I+1;
    else {
      H=I-1;
      if (C==0)
        L=I;
    }
  }
  return L;
} //Find

void AddStr(char *s) {
  int n,i;

  n=Find(s,Coll,Len);

  if ((Coll[n]) && (strcmp(s,Coll[n])==0)) return;
  if (Len>=COLLEN-1) return;

  for (i=Len; i>=n; i--)
    Coll[i]=Coll[i-1];
  Coll[n]=strdup(s);
  Len++;
} //AddStr

void ClearStr(void) {
  int i;

  for (i=0; i<Len; i++) {
    free(Coll[i]);
    Coll[i]=NULL;
  }
  Len=0;
  for (i=0; i<Len2; i++) {
    free(Coll2[i]);
    Coll2[i]=NULL;
  }
  Len2=0;
} //ClearStr

long look(FILE *F, char *key) {
 long Min,Max,Mid,Size;
 char w[80];

 Min=0;
 fseek(F,0,SEEK_END);
 Size=Max=ftell(F);
 if (Size==0) return -1;
 Mid=Size;

 while (Max-Min>1) {
   Mid=(Max+Min)/2;
   if (Mid>Size) return -1;
   fseek(F,Mid,SEEK_SET);
   if (Mid)
     ReadLn(F); //probably a partial line
   ReadWordLn(F,w);

   if (strcmp(w,key)<0)
     Min=Mid;
   else
     Max=Mid;
 }
 if (Min>Size) return -1;
 fseek(F,Min,SEEK_SET);
 if (Min)
   ReadLn(F);  //probably a partial line

 for (;;) {
   Min=ftell(F);
   ReadWordLn(F,w);
   if (strcmp(w,key)>=0) break;
 }
 fseek(F,Min,SEEK_SET);
 return Min;
} //look

int MaxL=0;

void load(char *name, long pos, FILE *out) {
 char fname[MAXLEN];
 char buf[MAXLEN];
 char *p;
 FILE *F;

 strcpy(fname,path);
 strcat(fname,name);
 strcat(fname,".html");

 F=fopen(fname,"r");
 if (F==NULL) return;
 fseek(F,pos,SEEK_SET);

 while (!feof(F)) {
   ReadHTMLWord(F,buf);
   if (strlen(buf)>MaxL) MaxL=strlen(buf);

   p=buf;
   while (*p) getword(&p);
   fprintf(out,"%s",buf);

   if (strstr(buf,"</dl>")) break;
 }

 fclose(F);
} //load

char prevmode=0;

void fragments(char *s, FILE *out) {
  char *p,*ss;
  char mode;
  char name[80];
  char spos[80];
  long pos;
  int i,n2;

  ss=s+1;
  n2=Find(ss,Coll2,Len2);
  if ((Coll2[n2]) && (strcmp(ss,Coll2[n2])==0)) return;

  mode = *s++;
  p = name;
  while (*s && isalpha(*s)) *p++ = *s++;
  *p = 0;

  p = spos;
  while (*s) *p++ = *s++;
  *p = 0;

  sscanf(spos,"%d",&pos);
  //printf("mode='%c' name='%s' pos='%d'\n",mode,name,pos);

  switch (mode) {
   case '1':
    if (!strchr(Mode,'v')) return;
    break;
   case '2':
    if (!strchr(Mode,'t')) return;
    break;
   case '3':
    if (!strchr(Mode,'k')) return;
    break;
   case '4':
    if (!strchr(Mode,'e')) return;
    break;
   case '5':
    if (!strchr(Mode,'k')) return;
    if (!strchr(Mode,'e')) return;
    break;
  }

  if (prevmode && prevmode!=mode)
    fprintf(out,"\n<hr />\n");
  prevmode=mode;

  load(name,pos,out);
  fprintf(out,"\n<hr />\n");
  //printf("max=%d\n",MaxL);

  if (Len2>=COLLEN-1) return;
  for (i=Len2; i>=n2; i--)
    Coll2[i]=Coll2[i-1];
  Coll2[n2]=strdup(ss);
  Len2++;

} //fragments

/* Deksesuma litero */
int _hex (char c1, char c2) {
  int res;
  if ('0'<=c1 && c1<='9') res=c1-'0';
  else res=10+c1-'A';
  if ('0'<=c2 && c2<='9') res=16*res+c2-'0';
  else res=16*res+10+c2-'A';
  return res;
} //_hex

void AnaliseRequest(char *s, char *q) {
  char *p,*pp;

  Mode[0]=0;
  if (rep(s,"&p=on","")!=NULL) strcat(Mode,"p");
  if (rep(s,"&v=on","")!=NULL) strcat(Mode,"v");
  if (rep(s,"&t=on","")!=NULL) strcat(Mode,"t");
  if (rep(s,"&e=on","")!=NULL) strcat(Mode,"e");
  if (rep(s,"&k=on","")!=NULL) strcat(Mode,"k");
  p=strchr(s,'&');
  if (p) *p=0;

  match(&s,"?");
  match(&s,"s=");
  while (rep(s,"+"," "));

  p=s; pp=q;
  while (*p) {
    if (*p!='%') *pp++=*p++;
    else {    //deksesuma litero
      *pp++=(char)_hex(p[1],p[2]);
      p+=3;
    }
  }
  *pp=0;

  uni_decode(q);
  toLower(q);
  if (!strchr(Mode,'p'))
    strcat(q,"*");
  while (rep(q,"**","*"));
  while (rep(q,"-",""));
  //printf("request: '%s'\n",q);
  //printf("Mode: '%s'\n",Mode);
} //AnaliseRequest

void prolog(FILE *out,char *base) {
  fprintf(out,
    "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\"\n"
    "  \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">\n"
    "<html xmlns=\"http://www.w3.org/1999/xhtml\">\n"
    "<head>\n"
    "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=windows-1251\" />\n"
    "<base href=\"%s\" />\n"
    "<link rel=\"stylesheet\" type=\"text/css\" href=\"vortaro.css\" />\n"
    "<title> </title>\n"
    "</head>\n"
    "<body>\n"
    "<div>\n",
    base);
} //prolog

void epilog(FILE *out) {
  fprintf(out,
    "<hr size=\"6\" />\n"
    "</div>\n"
    "</body>\n"
    "</html>\n");
} //epilog

void doCGI(char *request, FILE *out, char *base) {
  FILE *F;
  long n;
  char s[80];
  char fname[MAXLEN];
  int i;
  char *p;

  if (*request==0) return;
  prolog(out,base);
  AnaliseRequest(request,q);
  if (strcmp(q,"*")==0) {
    epilog(out);
    return;
  }

  strcpy(q0,q);
  p=strchr(q0,'*');
  if (p) *p=0;

  strcpy(fname,path);
  strcat(fname,"index.ind");
  F=fopen(fname,"rb");
  if (F==NULL) return;

  n=look(F,q0);

  if (n==-1) return;

  while (!feof(F)) {
    ReadWord(F,s);
    if (strncmp(s,q0,strlen(q0))) break;
    if (!wcmp0(q,s)) {
      ReadLn(F);
      continue;
    }
    for (;;) {
      int b=ReadWord(F,s);
      if (s[0]) AddStr(s);
      if (!b) break;
    }
  } //while

  for (i=0; i<Len; i++)
    fragments(Coll[i],out);
  ClearStr();

  epilog(out);
} //doCGI
